// Setup grid
// sass-lint:disable no-vendor-prefixes
@mixin grid($cols: 1, $gutter: map-get($grid, 'gutter'), $items: map-get($grid, 'items'), $element: map-get($grid, 'element'), $minmax: '', $minmaxPer: '') {
  $current-row: 1;
  $current-column: 1;
  $columns: repeat($cols, 1fr);
  $areas: ();

  @for $i from 1 through $items {
    @if $current-column > $cols {
      $current-column: 1;
      $current-row: $current-row + 1;
      $areas: append($areas, unquote('" "'));
    }

    > #{$element}:nth-of-type(#{$i}) {
      grid-area: unquote('area-' + $current-row + '-' + $i);

      @media screen and (-webkit-min-device-pixel-ratio: 0) {
        grid-column: $current-column;
        grid-row: $current-row;
      }

      @-moz-document url-prefix() {
        grid-column: $current-column;
        grid-row: $current-row;
      }
    }

    $areas: append($areas, unquote('area-' + $current-row + '-' + $i));
    $current-column: $current-column + 1;
  }

  @if $current-column < $cols {
    @for $i from 1 through ($cols - ($current-column - 1)) {
      $areas: append($areas, unquote('. '));
    }
  }

  @if $minmax != '' {
    $columns: repeat($cols, $minmax);
  }

  @if $minmaxPer != '' {
    $columns: $minmaxPer;
  }

  display: grid;
  grid-gap: $gutter;
  grid-template-areas: unquote('"#{$areas}"');
  grid-template-columns: $columns;
  grid-template-rows: repeat($current-row, auto);
  width: 100%;
}

// Vertically align
@mixin grid-center {
  align-items: center;
  display: grid;
}

// Span columns
@mixin col-span($start: 1, $end: 1) {
  @if $end != 1 {
    grid-column: #{$start} / span #{$end};
  } @else {
    grid-column: 1;
  }
}

// Span rows
@mixin row-span($start: 1, $end: 1) {
  grid-row: #{$start} / #{$end};
}
